package cn.estsh.i3plus.ext.mes.pcn.api.busi;

import cn.estsh.i3plus.pojo.mes.bean.MesProduceSn;
import cn.estsh.i3plus.pojo.mes.bean.MesQueueOrder;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import io.swagger.annotations.ApiOperation;

import java.util.List;
import java.util.Map;

public interface IMesProduceSnExtService {

    @ApiOperation(value = "根据零件条码查询零件条码信息")
    List<MesProduceSn> getProduceSnList(String organizeCode, List<String> productSnList);

    @ApiOperation(value = "根据零件条码ID查询零件条码信息")
    MesProduceSn getProduceSn(String organizeCode, Long id);

    @ApiOperation(value = "根据零件条码查询零件条码信息")
    Map<String, List<MesProduceSn>> getProduceSnMap(String organizeCode, List<String> productSnList);

    @ApiOperation(value = "根据生产工单,生产线,工位查询工位队列信息")
    List<MesQueueOrder> getQueueOrderList(String organizeCode, String workCenterCode, String workCellCode, String workOrderNo);

    @ApiOperation(value = "根据零件条码,生产线,工位查询工位队列信息")
    List<MesQueueOrder> getQueueOrderList(String organizeCode, String workCenterCode, String workCellCode, List<String> productSnList);

    @ApiOperation(value = "根据零件条码,生产线,工位查询工位队列信息")
    Map<String, List<MesQueueOrder>> getQueueOrderMap(String organizeCode, String workCenterCode, String workCellCode, List<String> productSnList);

    @ApiOperation(value = "根据零件条码ID修改条码状态,工位")
    void saveProduceSnList(StationRequestBean reqBean, Integer snStatus, List<Long> idList);

    MesProduceSn insert(MesProduceSn item);

    void update(MesProduceSn item);
}
