package cn.estsh.i3plus.ext.mes.pcn.apiservice.controller.busi;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesEnumDetailService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.mes.bean.MesEnumDetail;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @Description : 枚举明细配置
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/9 19:27
 * @Modify:
 **/
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesEnumDetail")
public class MesEnumDetailController {

    @Autowired
    private IMesEnumDetailService mesEnumDetailService;

    @GetMapping("/find")
    @ApiOperation(value = "查询包装明细")
    public ResultBean findMesEnumDetail(MesEnumDetail mesEnumDetail) {
        try {
            ValidatorBean.checkNotNull(mesEnumDetail.getEnumCode(), "枚举代码不能为空");
            mesEnumDetail.setOrganizeCode(AuthUtil.getOrganizeCode());
            List<MesEnumDetail> mesEnumDetailList = mesEnumDetailService.findMesEnumDetail(mesEnumDetail);
            return ResultBean.success("查询成功").setResultList(mesEnumDetailList);
        } catch (ImppBusiException imppException) {
            return ResultBean.fail(imppException);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }
}
