package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.pcn.api.base.IMesTemplateService;
import cn.estsh.i3plus.ext.mes.pcn.apiservice.util.MesPcnException;
import cn.estsh.i3plus.platform.common.util.MesPcnConstWords;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesLabelTemplate;
import cn.estsh.i3plus.pojo.mes.bean.MesLabelTemplateParam;
import cn.estsh.i3plus.pojo.mes.repository.MesLabelTemplateParamRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesLabelTemplateRepository;
import org.apache.shiro.util.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description : 打印模板
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/13 17:51
 * @Modify:
 **/
@Service
public class MesTemplateServiceImpl implements IMesTemplateService {

    @Autowired
    private MesLabelTemplateRepository mesLabelTemplateRDao;

    @Autowired
    private MesLabelTemplateParamRepository mesLabelTemplateParamRDao;

    @Override
    public MesLabelTemplate getMesLabelTemplate(String templateCode) {
        // 根据标签模板代码，查询【MES_标签模板表】，获取对应的方法代码
        MesLabelTemplate labelTemplate = mesLabelTemplateRDao.getByProperty(
                new String[]{MesPcnConstWords.IS_VALID, MesPcnConstWords.IS_DELETED, "templateCode"},
                new Object[]{CommonEnumUtil.IS_VAILD.VAILD.getValue(), CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(), templateCode});

        if (labelTemplate == null) {
            MesPcnException.throwMesBusiException("标签模板代码【%s】在标签模板表不存在！", templateCode);
        }

        // 根据模板代码查询模板参数信息
        List<MesLabelTemplateParam> templateParamList = mesLabelTemplateParamRDao.findByProperty(new String[]{"templateCode",
                        MesPcnConstWords.IS_VALID, MesPcnConstWords.IS_DELETED},
                new Object[]{templateCode, CommonEnumUtil.IS_VAILD.VAILD.getValue(),
                        CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue()});

        if (CollectionUtils.isEmpty(templateParamList)) {
            MesPcnException.throwMesBusiException("标签模板代码【%s】在标签模板明细表不存在！", templateCode);
        }
        labelTemplate.setLabelTemplateParamList(templateParamList);

        return labelTemplate;
    }
}
